!c Description: 

!c   ϳإǥ deepconv/arare
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2004, All rights reserved

program arare
  use gt4_history
  use gridset
  use fileset, only: fileset_init
  use expname, only: expname_init
  use if_diff, only: ss_dx_ss, fs_dx_fs, sf_dx_sf

  implicit none

  real(8), allocatable  :: ss_Exner_A(:,:)
  real(8), allocatable  :: ss_DExnerDX_A(:,:)
  real(8), allocatable  :: ss_DExnerDXAnl_A(:,:)
  real(8), allocatable  :: ss_ExnerError_A(:,:)
  real(8), allocatable  :: fs_VelX_A(:,:)
  real(8), allocatable  :: fs_DVelXDX_A(:,:)
  real(8), allocatable  :: fs_DVelXDXAnl_A(:,:)
  real(8), allocatable  :: fs_VelXError_A(:,:)
  real(8), allocatable  :: sf_VelZ_A(:,:)
  real(8), allocatable  :: sf_DVelZDX_A(:,:)
  real(8), allocatable  :: sf_DVelZDXAnl_A(:,:)
  real(8), allocatable  :: sf_VelZError_A(:,:)
  real(8), allocatable  :: ss_Exner_B(:,:)
  real(8), allocatable  :: fs_VelX_B(:,:)
  real(8), allocatable  :: sf_VelZ_B(:,:)
  real(8), allocatable  :: fs_Fx_B(:,:)
  real(8), allocatable  :: sf_Fz_B(:,:)
  real(8), allocatable  :: ss_VelDiv_B(:,:)

  real(8), parameter :: pi = 3.14159
  integer            :: i 

  type(gt_history) :: ss_reg, fs_reg, sf_reg
  type(gt_history) :: ss_dim, fs_dim, sf_dim
  

!!!
!!!
!!!
  !--- I/O ե̾ν
  call fileset_init
  
  !--- ʻν
  call gridset_init
  
  !--- ϥե
  call OpenRegFile
  call OpenDimFile


!!!
!!!γ, 
!!!  
  call ArareAlloc
  call ArareArrayInit


!!!
!!!׻
!!!

  ss_DExnerDX_A = ss_dx_ss(ss_Exner_A)
  ss_ExnerError_A = ss_DExnerDX_A - ss_DExnerDXAnl_A

  fs_DVelXDX_A = fs_dx_fs(fs_VelX_A)
  fs_VelXError_A = fs_DVelXDX_A - fs_DVelXDXAnl_A

  sf_DVelZDX_A = sf_dx_sf(sf_VelZ_A)
  sf_VelZError_A = sf_DVelZDX_A - sf_DVelZDXAnl_A

  !--- ե
  call OutputRegFile
  call OutputDimFile
     
  
  !--- ϥեΥ
  call CloseRegFile
  call CloseDimFile

  
contains
  
  subroutine ArareAlloc
    allocate(ss_Exner_A(DimXMin:DimXMax, DimZMin:DimZMax),  &
         & ss_DExnerDX_A(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & ss_DExnerDXAnl_A(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & ss_ExnerError_A(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & fs_VelX_A(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & fs_DVelXDX_A(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & fs_DVelXDXAnl_A(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & fs_VelXError_A(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & sf_VelZ_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_DVelZDX_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_DVelZDXAnl_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZError_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_Fx_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_Fz_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_VelDiv_B(DimXMin:DimXMax, DimZMin:DimZMax) )
  end subroutine ArareAlloc

  subroutine ArareArrayInit
    do i = DimXMin, DimXMax
       ss_Exner_A(i, DimXMin:DimZMax) =   & 
            & sin(2 * pi * s_X(i) / ( XMax - XMin) ) 
    end do
    ss_Exner_B = 0.0d0
    ss_DExnerDX_A = 0.0d0
    do i = DimXMin, DimXMax
       ss_DExnerDXAnl_A(i, DimXMin:DimXMax) =   & 
            & 2 * pi / (XMax - XMin) * cos(2 * pi * s_X(i) / ( XMax - XMin) ) 
    end do

    do i = DimXMin, DimXMax
       fs_VelX_A(i, DimXMin:DimXMax) =  &
            & sin(2 * pi * f_X(i) / ( XMax - XMin ) )
    end do
    fs_VelX_B = 0.0d0
    fs_DVelXDX_A = 0.0d0
    do i = DimXMin, DimXMax
       fs_DVelXDXAnl_A(i, DimXMin:DimXMax) =  &
            & 2 * pi / (XMax - XMin) * cos(2 * pi * f_X(i) / (XMax - XMin) )
    end do
    fs_VelXError_A = 0.0d0

    do i = DimXmin, DimXMax
       sf_VelZ_A(i, DimXMin:DimXMax) = &
            & sin(2 * pi * s_X(i) / ( XMax - Xmin ) )
    end do
    sf_VelZ_B = 0.0d0
    sf_DVelZDX_A = 0.0d0
    do i = DimXMin, DimXMax
       sf_DVelZDXAnl_A(i, DimXMin:DimXMax) =  &
            & 2 * pi / (XMax - XMin) * cos(2 * pi * s_X(i) / (XMax - XMin) )
    end do
    sf_VelZError_A = 0.0d0

    fs_Fx_B = 0.0d0
    sf_Fz_B = 0.0d0

    ss_VelDiv_B = 0.0d0

  end subroutine ArareArrayInit



  !--- gtool4 ϴϢ
  subroutine OpenRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax, &
         & NX, NZ, f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_RegFile, sf_RegFile, ss_RegFile
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_RegFile,                               &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/NX+1, NZ/),                       &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/), origin=0.0,              &
         & interval=0.0, &
         & history = fs_reg)
    
    ! ѿ
    call HistoryPut('x', f_X(RegXMin: RegXMax), fs_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), fs_reg)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_RegFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/NX, NZ+1/),                       &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), sf_reg)
    call HistoryPut('z', f_Z(RegXMin: RegXMax), sf_reg)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_RegFile,                            &         
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z'/),                         &
         & dimsizes=(/NX, NZ/),                       &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate'/),                 &
         & units=(/'m','m'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ss_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), ss_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), ss_reg)
    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_reg)    
    call HistoryAddVariable(                             &
         & varname='DExnerDX', dims=(/'x','z'/),        &
         & longname='nondimensional pressure diffentinated by x', units='1',&
         & xtype='double',                               & 
         & history = ss_reg)    
    call HistoryAddVariable(                             &
         & varname='DExnerDXAnl', dims=(/'x','z'/),        &
         & longname='nondimensional pressure diffentinated analitically', &
         & units='1',&
         & xtype='double',                               & 
         & history = ss_reg)    
    call HistoryAddVariable(                             &
         & varname='ExnerError', dims=(/'x','z'/),        &
         & longname='error', units='1',&
         & xtype='double',                               & 
         & history = ss_reg)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z'/),             &
         & longname='zonal velocity',         &
         & units='m/s', xtype='double',                & 
         & history = fs_reg)        
    call HistoryAddVariable(                            &
         & varname='DVelXDX', dims=(/'x','z'/),             &
         & longname='zonal velocity diffrentinated by X',         &
         & units='m/s', xtype='double',                & 
         & history = fs_reg)        
    call HistoryAddVariable(                            &
         & varname='DVelXDXAnl', dims=(/'x','z'/),             &
         & longname='zonal velocity diffrentinated analitically',         &
         & units='m/s', xtype='double',                & 
         & history = fs_reg)        
    call HistoryAddVariable(                            &
         & varname='VelXError', dims=(/'x','z'/),             &
         & longname='error',         &
         & units='m/s', xtype='double',                & 
         & history = fs_reg)        
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z'/),             &
         & longname='vertical velocity',         &
         & units='m/s', xtype='double',                & 
         & history = sf_reg)    
    call HistoryAddVariable(                            &
         & varname='DVelZDX', dims=(/'x','z'/),             &
         & longname='vertical velocity diffrentinated by X',         &
         & units='m/s', xtype='double',                & 
         & history = sf_reg)    
    call HistoryAddVariable(                            &
         & varname='DVelZDXAnl', dims=(/'x','z'/),             &
         & longname='vertical velocity diffrentinated analitically',    &
         & units='m/s', xtype='double',                & 
         & history = sf_reg)    
    call HistoryAddVariable(                            &
         & varname='VelZError', dims=(/'x','z'/),             &
         & longname='error',         &
         & units='m/s', xtype='double',                & 
         & history = sf_reg)     
   
  end subroutine OpenRegFile


  subroutine OutputRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax

    !--- ʡؿ
    call HistoryPut('Exner', &
         & ss_Exner_A(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('DExnerDX', &
         & ss_DExnerDX_A(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('DExnerDXAnl', &
         & ss_DExnerDXAnl_A(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('ExnerError', &
         & ss_ExnerError_A(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    !--- ®
    call HistoryPut('VelX', &
         & fs_VelX_A(RegXMin:RegXMax, RegZMin+1:RegZMax), fs_reg)
    call HistoryPut('DVelXDX', &
         & fs_DVelXDX_A(RegXMin:RegXMax, RegZMin+1:RegZMax), fs_reg)
    call HistoryPut('DVelXDXAnl', &
         & fs_DVelXDXAnl_A(RegXMin:RegXMax, RegZMin+1:RegZMax), fs_reg)
    call HistoryPut('VelXError', &
         & fs_VelXError_A(RegXMin:RegXMax, RegZMin+1:RegZMax), fs_reg)
    !--- ®
    call HistoryPut('VelZ', &
         & sf_VelZ_A(RegXMin+1:RegXMax, RegZMin:RegZMax), sf_reg)
    call HistoryPut('DVelZDX', &
         & sf_DVelZDX_A(RegXMin+1:RegXMax, RegZMin:RegZMax), sf_reg)
    call HistoryPut('DVelZDXAnl', &
         & sf_DVelZDXAnl_A(RegXMin+1:RegXMax, RegZMin:RegZMax), sf_reg)
    call HistoryPut('VelZError', &
         & sf_VelZError_A(RegXMin+1:RegXMax, RegZMin:RegZMax), sf_reg)
  end subroutine OutputRegFile
  
  subroutine CloseRegFile
    call HistoryClose( ss_reg )
    call HistoryClose( fs_reg )
    call HistoryClose( sf_reg )
  end subroutine CloseRegFile


  !--- gtool4 ϴϢ
  subroutine OpenDimFile
    use gridset, only: f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_DimFile, sf_DimFile, ss_DimFile
    
    integer::   N
    
    N = size(f_X, 1)

    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/N, N/),                           &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/), origin=0.0,              &
         & interval=0.0, &
         & history = fs_dim)
    
    ! ѿ
    call HistoryPut('x', f_X, fs_dim)
    call HistoryPut('z', s_Z, fs_dim)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/N, N/),                           &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, sf_dim)
    call HistoryPut('z', f_Z, sf_dim)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_DimFile,                            &
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z'/),                             &
         & dimsizes=(/N, N/),                            &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate'/),                 &
         & units=(/'m','m'/), origin=0.0,                &
         & interval=0.0,                                 &
         & history = ss_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, ss_dim)
    call HistoryPut('z', s_Z, ss_dim)
    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    call HistoryAddVariable(                             &
         & varname='DExnerDX', dims=(/'x','z'/),        &
         & longname='nondimensional pressure diffentinated by x', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    call HistoryAddVariable(                             &
         & varname='DExnerDXAnl', dims=(/'x','z'/),        &
         & longname='nondimensional pressure diffentinated by x', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    call HistoryAddVariable(                             &
         & varname='ExnerError', dims=(/'x','z'/),        &
         & longname='error', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z'/),        &
         & longname='zonal velocity',                   &
         & units='m/s', xtype='double',                 & 
         & history = fs_dim)        
    call HistoryAddVariable(                            &
         & varname='DVelXDX', dims=(/'x','z'/),             &
         & longname='zonal velocity diffrentinated by X',         &
         & units='m/s', xtype='double',                & 
         & history = fs_dim)        
    call HistoryAddVariable(                            &
         & varname='DVelXDXAnl', dims=(/'x','z'/),             &
         & longname='zonal velocity diffrentinated analitically',         &
         & units='m/s', xtype='double',                & 
         & history = fs_dim)        
    call HistoryAddVariable(                            &
         & varname='VelXError', dims=(/'x','z'/),             &
         & longname='error',         &
         & units='m/s', xtype='double',                & 
         & history = fs_dim)            ! ®
    !--- ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z'/),        &
         & longname='vertical velocity',                &
         & units='m/s', xtype='double',                 & 
         & history = sf_dim)    
    call HistoryAddVariable(                            &
         & varname='DVelZDX', dims=(/'x','z'/),             &
         & longname='vertical velocity diffrentinated by X',         &
         & units='m/s', xtype='double',                & 
         & history = sf_dim)    
    call HistoryAddVariable(                            &
         & varname='DVelZDXAnl', dims=(/'x','z'/),             &
         & longname='vertical velocity diffrentinated analitically',    &
         & units='m/s', xtype='double',                & 
         & history = sf_dim)    
    call HistoryAddVariable(                            &
         & varname='VelZError', dims=(/'x','z'/),             &
         & longname='error',         &
         & units='m/s', xtype='double',                & 
         & history = sf_dim)     
    
  end subroutine OpenDimFile


  subroutine OutputDimFile
    !--- ʡؿ
    call HistoryPut('Exner', ss_Exner_A, ss_dim)
    call HistoryPut('DExnerDX', ss_DExnerDX_A, ss_dim)
    call HistoryPut('DExnerDXAnl', ss_DExnerDXAnl_A, ss_dim)
    call HistoryPut('ExnerError', ss_ExnerError_A, ss_dim)
    !--- ®
    call HistoryPut('VelX', fs_VelX_A, fs_dim)
    call HistoryPut('DVelXDX', fs_DVelXDX_A, fs_dim)
    call HistoryPut('DVelXDXAnl', fs_DVelXDXAnl_A, fs_dim)
    call HistoryPut('VelXError', fs_VelXError_A, fs_dim)
    !--- ®
    call HistoryPut('VelZ', sf_VelZ_A, sf_dim)
    call HistoryPut('DVelZDX', sf_DVelZDX_A, sf_dim)
    call HistoryPut('DVelZDXAnl', sf_DVelZDXAnl_A, sf_dim)
    call HistoryPut('VelZError', sf_VelZError_A, sf_dim)
  end subroutine OutputDimFile
  
  subroutine CloseDimFile
    call HistoryClose( ss_dim )
    call HistoryClose( fs_dim )
    call HistoryClose( sf_dim )
  end subroutine CloseDimFile


end program arare
